Subject: [RFC PATCH 0/9] dt: dependencies (for deterministic driver initialization order based on the DT)

From: [email-masked] (Alexander Holler)
Date: Wed, 14 May 2014 19:45:54 +0200

Am 14.05.2014 19:30, schrieb Rob Herring:
> On Wed, May 14, 2014 at 11:23 AM, Alexander Holler <[email-masked]> wrote:
>> Am 14.05.2014 18:05, schrieb Grant Likely:
>>
>>> On Wed, May 14, 2014 at 4:02 PM, Alexander Holler <[email-masked]>
>>> wrote:
>>>>
>>>> Am 14.05.2014 16:19, schrieb Grant Likely:
>>>>
>>>>
>>>>> Rather than a dtb schema change, for the most common properties (irqs,
>>>>> clocks, gpios), we could extract dependencies at boot time. I don't like
>>>>> the idea of adding a separate depends-on property because it is very
>>>>> easy to get it out of sync with the actual binding data (dtc is not the
>>>>> only tool that manipulates .dtbs. Firmware will fiddle with it too).
>>>>
>>>>
>>>>
>>>> Then that stuff has to fiddle correct. Sorry, but trying to solve all
>>>> problems right from the beginning just leads to endless talks with no end
>>>> and nothing will happen at all because nobody aggrees how to start.
>>>
>>>
>>> I appreciate the problem that you're trying to solve and why you're
>>> using the dtc approach. My job is to poke at the solution and make
>>> sure it is going to be reliable. Making sure all users know how to
>>> fiddle with the new property correctly is not a trivial problem,
>>> especially when it is firmware that will not necessarily be updated.
>>
>>
>> The answer is just that they don't have to use this feature.
>
> It's not just about users, but maintainers have to carry the code and
> anything tied to DT is difficult to change or remove.
>
> Lots of inter-dependencies are already described in DT. We should
> leverage those first and then look at how to add dependencies that are
> not described.

Again, that's what this feature is about. One of the problems it solves 
is that those dependencies which are described in the DT source in form 
of phandle reference, do disappear in the blobs because the init-system 
would have to know all bindings in order to identify phandle references 
(the dependencies) again.

>> It is more meant as a long-term solution to fix for the problem of
>> increasing hard-coded workarounds which all are trying to fix the
>> initialization order of drivers. Hardware has become a lot more complicated
>> than it was in the good old days, and I think the time is right trying to
>> adopt the init-system to this new century instead of still adding
>> workarounds here and there.
>
> I don't know when the good old days were, but this has been a problem
> in embedded systems for as long as I have worked on Linux.

Yes, but stuff wasn't as complicated as today, which means it was 
relatively easy to manualy solve dependency problems. But if you look at 
complicated SOCs like the OMAP, it's much better to let the machine 
solve the dependencies to get the initialization order instead of still 
trying to do this manually.

>>> I'm not saying flat out 'no' here, but before I merge anything, I have
>>> to be reasonably certain that the feature is not going to represent a
>>> maintenance nightmare over the long term.
>>
>>
>> The maintenance nightmare is already present in form of all the workarounds
>> which are trying to fix the initialzation order necessary for modern
>> hardware.
>
> Do you have concrete examples or cases where deferred probe does not work?

Why do people come back to the deferred probe stuff?

One of the biggest problem of the deferred probe stuff is the problem 
how to identify real problems if everything ends up with a deferred 
probe when an error occurs? That means if you display an error whenever 
something is deferred, the log becomes almost unreadable. If you don't 
display an error, you never will see an error. And how do you display 
the real error when deferred probes finally do fail? The deferred probe 
stuff doesn't has any information about the underlying error, so it 
can't display it.

Anyway, this feature is totally independ of the deferred probe stuff and 
both can friendly live together.

Regards,

Alexander Holler